本文整理汇总了C#中Form.get_CurveLoopReferencesOnProfile方法的典型用法代码示例。如果您正苦于以下问题:C# Form.get_CurveLoopReferencesOnProfile方法的具体用法?C# Form.get_CurveLoopReferencesOnProfile怎么用?C# Form.get_CurveLoopReferencesOnProfile使用的例子?那么恭喜您, 这里精选的方法代码示例或许可以为您提供帮助。您也可以进一步了解该方法所在类Form
的用法示例。
在下文中一共展示了Form.get_CurveLoopReferencesOnProfile方法的3个代码示例,这些例子默认根据受欢迎程度排序。您可以为喜欢或者感觉有用的代码点赞,您的评价将有助于系统推荐出更棒的C#代码示例。
示例1: MoveVertexesOnAddedProfile
/// <summary>
/// Move the form vertexes on added profile
/// </summary>
/// <param name="form">The form contains the vertexes</param>
/// <param name="profileIndex">Index of added profile</param>
private void MoveVertexesOnAddedProfile(Form form, int profileIndex)
{
Autodesk.Revit.DB.XYZ offset = new Autodesk.Revit.DB.XYZ (0, m_vertexOffsetOnMiddleProfile, 0);
ReferenceArray ra = form.get_CurveLoopReferencesOnProfile(profileIndex, 0);
foreach (Reference r in ra)
{
ReferenceArray ra2 = form.GetControlPoints(r);
foreach (Reference r2 in ra2)
{
Point vertex = form.GetGeometryObjectFromReference(r2) as Point;
if (Math.Abs(vertex.Coord.X) < Epsilon)
{
MoveSubElement(form, r2, offset);
break;
}
}
}
}
示例2: matchOrAddFormCurveToReferenceCurveMap
bool matchOrAddFormCurveToReferenceCurveMap(Form formElement, ReferenceArrayArray refArrArr, bool doMatch)
{
if (formElement.Id != _formId && doMatch)
{
return false;
}
else if (!doMatch)
_formId = formElement.Id;
if (doMatch && _sformCurveToReferenceCurveMap.Count == 0)
return false;
else if (!doMatch)
_sformCurveToReferenceCurveMap = new Dictionary<ElementId, ElementId>();
for (int indexRefArr = 0; indexRefArr < refArrArr.Size; indexRefArr++)
{
if (indexRefArr >= refArrArr.Size)
{
if (!doMatch)
_sformCurveToReferenceCurveMap.Clear();
return false;
}
if (refArrArr.get_Item(indexRefArr).Size != formElement.get_CurveLoopReferencesOnProfile(indexRefArr, 0).Size)
{
if (!doMatch)
_sformCurveToReferenceCurveMap.Clear();
return false;
}
for (int indexRef = 0; indexRef < refArrArr.get_Item(indexRefArr).Size; indexRef++)
{
Reference oldRef = formElement.get_CurveLoopReferencesOnProfile(indexRefArr, 0).get_Item(indexRef);
Reference newRef = refArrArr.get_Item(indexRefArr).get_Item(indexRef);
if ((oldRef.ElementReferenceType != ElementReferenceType.REFERENCE_TYPE_NONE &&
oldRef.ElementReferenceType != ElementReferenceType.REFERENCE_TYPE_LINEAR) ||
(newRef.ElementReferenceType != ElementReferenceType.REFERENCE_TYPE_NONE &&
newRef.ElementReferenceType != ElementReferenceType.REFERENCE_TYPE_LINEAR) ||
oldRef.ElementReferenceType != newRef.ElementReferenceType)
{
if (!doMatch)
_sformCurveToReferenceCurveMap.Clear();
return false;
}
ElementId oldRefId = oldRef.ElementId;
ElementId newRefId = newRef.ElementId;
if (doMatch && (!_sformCurveToReferenceCurveMap.ContainsKey(newRefId) ||
_sformCurveToReferenceCurveMap[newRefId] != oldRefId)
)
{
return false;
}
else if (!doMatch)
_sformCurveToReferenceCurveMap[newRefId] = oldRefId;
}
}
return true;
}
示例3: MoveEdgesOnProfile
/// <summary>
/// Move the edges on profile
/// </summary>
/// <param name="form">The form contains the edge</param>
/// <param name="profileIndex">Index of the profile to be moved</param>
private void MoveEdgesOnProfile(Form form, int profileIndex)
{
Autodesk.Revit.DB.XYZ startOfTop = new Autodesk.Revit.DB.XYZ (-1 * m_topLength / 2, -1 * m_topWidth / 2, m_topHeight);
Autodesk.Revit.DB.XYZ offset1 = new Autodesk.Revit.DB.XYZ (m_profileOffset, 0, 0);
Autodesk.Revit.DB.XYZ offset2 = new Autodesk.Revit.DB.XYZ (-m_profileOffset, 0, 0);
Reference r1 = null;
Reference r2 = null;
ReferenceArray ra = form.get_CurveLoopReferencesOnProfile(profileIndex, 0);
foreach (Reference r in ra)
{
Line line = form.GetGeometryObjectFromReference(r) as Line;
if (line == null)
{
throw new Exception("Get curve reference on profile as line error.");
}
Autodesk.Revit.DB.XYZ pnt1 = line.Evaluate(0, false);
Autodesk.Revit.DB.XYZ pnt2 = line.Evaluate(1, false);
if (Math.Abs(pnt1.X - pnt2.X) < Epsilon)
{
if (pnt1.X < startOfTop.X)
{
r1 = r;
}
else
{
r2 = r;
}
}
}
if ((r1 == null) || (r2 == null))
{
throw new Exception("Get line on profile error.");
}
MoveSubElement(form, r1, offset1);
MoveSubElement(form, r2, offset2);
}